package keystash.gui;

import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.util.logging.Level;
import java.util.logging.Logger;
import keystash.KeyStashGUI;
import static keystash.KeyStashGUI.encryptDatabaseEntropyValue;
import static keystash.KeyStashGUI.encryptDatabaseLengthValue;
import static keystash.KeyStashGUI.encryptDatabasePasswordConfirmField;
import static keystash.KeyStashGUI.encryptDatabasePasswordField;
import static keystash.KeyStashGUI.encryptDatabasePasswordStrengthLabel;
import static keystash.KeyStashGUI.encryptDatabaseShowPhraseCheckBox;
import static keystash.KeyStashGUI.encryptDatabasejProgressBar;
import static keystash.KeyStashGUI.importEntropyValue;
import static keystash.KeyStashGUI.importLengthValue;
import static keystash.KeyStashGUI.importPasswordConfirmField;
import static keystash.KeyStashGUI.importPasswordField;
import static keystash.KeyStashGUI.importPasswordStrengthLabel;
import static keystash.KeyStashGUI.importShowPhraseCheckBox;
import static keystash.KeyStashGUI.importjProgressBar;
import static keystash.KeyStashGUI.newAccountEntropyValue;
import static keystash.KeyStashGUI.newAccountLengthValue;
import static keystash.KeyStashGUI.newAccountPasswordConfirmField;
import static keystash.KeyStashGUI.newAccountPasswordField;
import static keystash.KeyStashGUI.newAccountPasswordStrengthLabel;
import static keystash.KeyStashGUI.newAccountShowPhraseCheckBox;
import static keystash.KeyStashGUI.newAccountjProgressBar;
import keystash.crypto.WordBook;
import keystash.util.PasswordStrength;

public class Memorable {

    public static void newAccountGenerateMemorable() {

        try {
            newAccountPasswordField.setText(WordBook.generateRememberWordPhrase());
        } catch (NoSuchAlgorithmException | NoSuchProviderException ex) {
            Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
        }

        newAccountPasswordField.setEchoChar((char) 0);
        newAccountPasswordConfirmField.setEchoChar((char) 0);
        newAccountPasswordConfirmField.setText("");
        newAccountShowPhraseCheckBox.setSelected(true);
        newAccountjProgressBar.setValue(50);
        newAccountPasswordStrengthLabel.setText("Complexity: Good");
        char[] getPassword = newAccountPasswordField.getPassword();
        String checkPasswordString = new String(getPassword);
        int passLength = checkPasswordString.length();
        String passLengthString = String.valueOf(passLength);
        newAccountLengthValue.setText(passLengthString);
        double shannonEntropy = PasswordStrength.getShannonEntropy(checkPasswordString);
        String shannonEntropyString = String.valueOf(shannonEntropy);
        newAccountEntropyValue.setText(shannonEntropyString);

    }

    public static void importGenerateMemorable() {

        try {
            importPasswordField.setText(WordBook.generateRememberWordPhrase());
        } catch (NoSuchAlgorithmException | NoSuchProviderException ex) {
            Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
        }

        importPasswordField.setEchoChar((char) 0);
        importPasswordConfirmField.setEchoChar((char) 0);
        importPasswordConfirmField.setText("");
        importShowPhraseCheckBox.setSelected(true);
        importjProgressBar.setValue(50);
        importPasswordStrengthLabel.setText("Complexity: Good");
        char[] getPassword = importPasswordField.getPassword();
        String checkPasswordString = new String(getPassword);
        int passLength = checkPasswordString.length();
        String passLengthString = String.valueOf(passLength);
        importLengthValue.setText(passLengthString);
        double shannonEntropy = PasswordStrength.getShannonEntropy(checkPasswordString);
        String shannonEntropyString = String.valueOf(shannonEntropy);
        importEntropyValue.setText(shannonEntropyString);

    }

    public static void encryptDatabaseGenerateMemorable() {

        try {
            encryptDatabasePasswordField.setText(WordBook.generateRememberWordPhrase());
        } catch (NoSuchAlgorithmException | NoSuchProviderException ex) {
            Logger.getLogger(KeyStashGUI.class.getName()).log(Level.SEVERE, null, ex);
        }

        encryptDatabasePasswordField.setEchoChar((char) 0);
        encryptDatabasePasswordConfirmField.setEchoChar((char) 0);
        encryptDatabaseShowPhraseCheckBox.setSelected(true);
        encryptDatabasejProgressBar.setValue(50);
        encryptDatabasePasswordStrengthLabel.setText("Complexity: Good");
        char[] getPassword = encryptDatabasePasswordField.getPassword();
        String checkPasswordString = new String(getPassword);
        int passLength = checkPasswordString.length();
        String passLengthString = String.valueOf(passLength);
        encryptDatabaseLengthValue.setText(passLengthString);
        double shannonEntropy = PasswordStrength.getShannonEntropy(checkPasswordString);
        String shannonEntropyString = String.valueOf(shannonEntropy);
        encryptDatabaseEntropyValue.setText(shannonEntropyString);

    }

}
