package keystash.gui;

import java.awt.Color;
import java.awt.Component;
import static keystash.KeyStashGUI.showPreferencesANSICheckbox;
import static keystash.KeyStashGUI.showPreferencesClearClipboardSpinner;
import static keystash.KeyStashGUI.showPreferencesFrame;
import static keystash.KeyStashGUI.showPreferencesIterationSpinner;
import static keystash.KeyStashGUI.showPreferencesKeySizeComboBox;
import static keystash.KeyStashGUI.showPreferencesLengthMaximumMaxSpinner;
import static keystash.KeyStashGUI.showPreferencesLengthMaximumMinSpinner;
import static keystash.KeyStashGUI.showPreferencesLengthMinimumMaxSpinner;
import static keystash.KeyStashGUI.showPreferencesLengthMinimumMinSpinner;
import static keystash.KeyStashGUI.showPreferencesLowerCaseMaxSpinner;
import static keystash.KeyStashGUI.showPreferencesLowerCaseMinSpinner;
import static keystash.KeyStashGUI.showPreferencesNumeraryMaxSpinner;
import static keystash.KeyStashGUI.showPreferencesNumeraryMinSpinner;
import static keystash.KeyStashGUI.showPreferencesPhraseBlocksSpinner;
import static keystash.KeyStashGUI.showPreferencesRandomGenerationCheckbox;
import static keystash.KeyStashGUI.showPreferencesResetSettingsButton;
import static keystash.KeyStashGUI.showPreferencesSpecialCharMaxSpinner;
import static keystash.KeyStashGUI.showPreferencesSpecialCharMinSpinner;
import static keystash.KeyStashGUI.showPreferencesUpperCaseMaxSpinner;
import static keystash.KeyStashGUI.showPreferencesUpperCaseMinSpinner;
import static keystash.KeyStashGUI.showPreferencesWarningsCheckbox;
import static keystash.KeyStashGUI.showPreferencesWhitespaceCheckbox;
import keystash.util.Convert;
import keystash.util.Db;

public class Preferences {

    public static void keySizeComboBox() {

        int getKeySize = showPreferencesKeySizeComboBox.getSelectedIndex();
        int keySizeComboBox;

        if (getKeySize == 0) {
            keySizeComboBox = 128;
            Db.walletUpdateSettings(1, "secret_key_size", Convert.intToString(keySizeComboBox));
        }
        else if (getKeySize == 1) {
            keySizeComboBox = 256;
            Db.walletUpdateSettings(1, "secret_key_size", Convert.intToString(keySizeComboBox));
        }

    }

    public static void ansiCheckBox() {

        boolean checkBox = showPreferencesANSICheckbox.isSelected();
        String checkBoxString = Boolean.toString(checkBox);
        int tableId = 1;
        String where = "enable_ansi";

        if (checkBox) {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
        }
        else {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
        }

    }

    public static void iteration() {

        Component c = showPreferencesIterationSpinner.getEditor().getComponent(0);
        Object spinner = showPreferencesIterationSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int tableId = 1;
        String where = "secret_iteration";

        Db.walletUpdateSettings(tableId, where, spinnerString);

        if (spinnerInt > 5000) {
            c.setForeground(Color.BLUE.darker());
        }
        else {
            c.setForeground(Color.BLACK);
        }
    }

    public static void warningsCheckBox() {

        boolean checkBox = showPreferencesWarningsCheckbox.isSelected();
        String checkBoxString = Boolean.toString(checkBox);
        int tableId = 1;
        String where = "show_warnings";

        if (checkBox) {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
        }
        else {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
        }

    }

    public static void whitespaceCheckBox() {

        boolean checkBox = showPreferencesWhitespaceCheckbox.isSelected();
        String checkBoxString = Boolean.toString(checkBox);
        int tableId = 1;
        String where = "enable_whitespace";

        if (checkBox) {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
        }
        else {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
        }

    }

    public static void randomGenerationCheckBox() {

        boolean checkBox = showPreferencesRandomGenerationCheckbox.isSelected();
        String checkBoxString = Boolean.toString(checkBox);
        int tableId = 1;
        String where = "random_generation";
        int getKeySize = Convert.stringToInt(Db.selectFromSettings("secret_key_size", "keystash_settings", "settings_id", 1));
        int keySizeComboBox = 0;

        if (getKeySize == 128) {
            keySizeComboBox = 0;
        }
        else if (getKeySize == 256) {
            keySizeComboBox = 1;
        }

        if (checkBox) {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
            showPreferencesPhraseBlocksSpinner.setEnabled(true);
            showPreferencesWhitespaceCheckbox.setEnabled(true);
            showPreferencesANSICheckbox.setEnabled(true);
            showPreferencesIterationSpinner.setEnabled(true);
            showPreferencesLengthMinimumMinSpinner.setEnabled(true);
            showPreferencesLengthMinimumMaxSpinner.setEnabled(true);
            showPreferencesLengthMaximumMinSpinner.setEnabled(true);
            showPreferencesLengthMaximumMaxSpinner.setEnabled(true);
            showPreferencesLowerCaseMinSpinner.setEnabled(true);
            showPreferencesLowerCaseMaxSpinner.setEnabled(true);
            showPreferencesUpperCaseMinSpinner.setEnabled(true);
            showPreferencesUpperCaseMaxSpinner.setEnabled(true);
            showPreferencesNumeraryMinSpinner.setEnabled(true);
            showPreferencesNumeraryMaxSpinner.setEnabled(true);
            showPreferencesSpecialCharMinSpinner.setEnabled(true);
            showPreferencesSpecialCharMaxSpinner.setEnabled(true);
            showPreferencesResetSettingsButton.setEnabled(true);
            showPreferencesKeySizeComboBox.setEnabled(true);
            showPreferencesPhraseBlocksSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("phrase_blocks", "keystash_settings", "settings_id", 1)));
            showPreferencesIterationSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("secret_iteration", "keystash_settings", "settings_id", 1)));
            showPreferencesWhitespaceCheckbox.setSelected(Convert.stringToBoolean(Db.selectFromSettings("enable_whitespace", "keystash_settings", "settings_id", 1)));
            showPreferencesANSICheckbox.setSelected(Convert.stringToBoolean(Db.selectFromSettings("enable_ansi", "keystash_settings", "settings_id", 1)));
            showPreferencesLengthMinimumMinSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("Length_minimum_min", "keystash_settings", "settings_id", 1)));
            showPreferencesLengthMinimumMaxSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("Length_minimum_max", "keystash_settings", "settings_id", 1)));
            showPreferencesLengthMaximumMinSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("Length_maximum_min", "keystash_settings", "settings_id", 1)));
            showPreferencesLengthMaximumMaxSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("Length_maximum_max", "keystash_settings", "settings_id", 1)));
            showPreferencesLowerCaseMinSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("lower_case_min", "keystash_settings", "settings_id", 1)));
            showPreferencesLowerCaseMaxSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("lower_case_max", "keystash_settings", "settings_id", 1)));
            showPreferencesUpperCaseMinSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("upper_case_min", "keystash_settings", "settings_id", 1)));
            showPreferencesUpperCaseMaxSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("upper_case_max", "keystash_settings", "settings_id", 1)));
            showPreferencesNumeraryMinSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("numerary_min", "keystash_settings", "settings_id", 1)));
            showPreferencesNumeraryMaxSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("numerary_max", "keystash_settings", "settings_id", 1)));
            showPreferencesSpecialCharMinSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("special_char_min", "keystash_settings", "settings_id", 1)));
            showPreferencesSpecialCharMaxSpinner.setValue(Convert.stringToInt(Db.selectFromSettings("special_char_max", "keystash_settings", "settings_id", 1)));
            showPreferencesKeySizeComboBox.setSelectedIndex(keySizeComboBox);
        }
        else {
            Db.walletUpdateSettings(tableId, where, checkBoxString);
            showPreferencesPhraseBlocksSpinner.setEnabled(false);
            showPreferencesIterationSpinner.setEnabled(false);
            showPreferencesWhitespaceCheckbox.setEnabled(false);
            showPreferencesANSICheckbox.setEnabled(false);
            showPreferencesLengthMinimumMinSpinner.setEnabled(false);
            showPreferencesLengthMinimumMaxSpinner.setEnabled(false);
            showPreferencesLengthMaximumMinSpinner.setEnabled(false);
            showPreferencesLengthMaximumMaxSpinner.setEnabled(false);
            showPreferencesLowerCaseMinSpinner.setEnabled(false);
            showPreferencesLowerCaseMaxSpinner.setEnabled(false);
            showPreferencesUpperCaseMinSpinner.setEnabled(false);
            showPreferencesUpperCaseMaxSpinner.setEnabled(false);
            showPreferencesNumeraryMinSpinner.setEnabled(false);
            showPreferencesNumeraryMaxSpinner.setEnabled(false);
            showPreferencesSpecialCharMinSpinner.setEnabled(false);
            showPreferencesSpecialCharMaxSpinner.setEnabled(false);
            showPreferencesResetSettingsButton.setEnabled(false);
            showPreferencesKeySizeComboBox.setEnabled(false);
        }

    }

    public static void clearClipBoard() {

        Object spinner = showPreferencesClearClipboardSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int tableId = 1;
        String where = "clear_clipboard";
        Db.walletUpdateSettings(tableId, where, spinnerString);

    }

    public static void phraseBlocks() {

        Object spinner = showPreferencesPhraseBlocksSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int tableId = 1;
        String where = "phrase_blocks";
        Db.walletUpdateSettings(tableId, where, spinnerString);

    }

    public static void lengthMinimumMin() {

        Object spinner = showPreferencesLengthMinimumMinSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("Length_minimum_max", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "Length_minimum_min";

        if (spinnerInt > spinnerIntNeighbour) {
            Dialog.showDialog("Minimum cant be above maximum value.", "Note");
            showPreferencesLengthMinimumMinSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void lengthMinimumMax() {

        Object spinner = showPreferencesLengthMinimumMaxSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("Length_minimum_min", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "Length_minimum_max";

        if (spinnerInt < spinnerIntNeighbour) {
            Dialog.showDialog("Maximum cant be below minimum value.", "Note");
            showPreferencesLengthMinimumMaxSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void lengthMaximumMin() {

        Object spinner = showPreferencesLengthMaximumMinSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("Length_maximum_max", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "Length_maximum_min";

        if (spinnerInt > spinnerIntNeighbour) {
            Dialog.showDialog("Minimum cant be above maximum value.", "Note");
            showPreferencesLengthMaximumMinSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void lengthMaximumMax() {

        Object spinner = showPreferencesLengthMaximumMaxSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("Length_maximum_min", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "Length_maximum_max";

        if (spinnerInt < spinnerIntNeighbour) {
            Dialog.showDialog("Maximum cant be below minimum value.", "Note");
            showPreferencesLengthMaximumMaxSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void lowerCaseMin() {

        Object spinner = showPreferencesLowerCaseMinSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("lower_case_max", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "lower_case_min";

        if (spinnerInt > spinnerIntNeighbour) {
            Dialog.showDialog("Minimum cant be above maximum value.", "Note");
            showPreferencesLowerCaseMinSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void lowerCaseMax() {

        Object spinner = showPreferencesLowerCaseMaxSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("lower_case_min", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "lower_case_max";

        if (spinnerInt < spinnerIntNeighbour) {
            Dialog.showDialog("Maximum cant be below minimum value.", "Note");
            showPreferencesLowerCaseMaxSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void upperCaseMin() {

        Object spinner = showPreferencesUpperCaseMinSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("upper_case_max", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "upper_case_min";

        if (spinnerInt > spinnerIntNeighbour) {
            Dialog.showDialog("Minimum cant be above maximum value.", "Note");
            showPreferencesUpperCaseMinSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void upperCaseMax() {

        Object spinner = showPreferencesUpperCaseMaxSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("upper_case_min", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "upper_case_max";

        if (spinnerInt < spinnerIntNeighbour) {
            Dialog.showDialog("Maximum cant be below minimum value.", "Note");
            showPreferencesUpperCaseMaxSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void numeryMin() {

        Object spinner = showPreferencesNumeraryMinSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("numerary_max", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "numerary_min";

        if (spinnerInt > spinnerIntNeighbour) {
            Dialog.showDialog("Minimum cant be above maximum value.", "Note");
            showPreferencesNumeraryMinSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));

        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void numeryMax() {

        Object spinner = showPreferencesNumeraryMaxSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("numerary_min", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "numerary_max";

        if (spinnerInt < spinnerIntNeighbour) {
            Dialog.showDialog("Maximum cant be below minimum value.", "Note");
            showPreferencesNumeraryMaxSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void specialCharMin() {

        Object spinner = showPreferencesSpecialCharMinSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("special_char_max", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "special_char_min";

        if (spinnerInt > spinnerIntNeighbour) {
            Dialog.showDialog("Minimum cant be above maximum value.", "Note");
            showPreferencesSpecialCharMinSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void specialCharMax() {

        Object spinner = showPreferencesSpecialCharMaxSpinner.getValue();
        String spinnerString = String.valueOf(spinner);
        int spinnerInt = Convert.stringToInt(spinnerString);
        int spinnerIntNeighbour = Convert.stringToInt(Db.selectFromSettings("special_char_min", "keystash_settings", "settings_id", 1));
        int tableId = 1;
        String where = "special_char_max";

        if (spinnerInt < spinnerIntNeighbour) {
            Dialog.showDialog("Maximum cant be below minimum value.", "Note");
            showPreferencesSpecialCharMaxSpinner.setValue(spinnerIntNeighbour);
            Db.walletUpdateSettings(tableId, where, Convert.intToString(spinnerIntNeighbour));
        }
        else {
            Db.walletUpdateSettings(tableId, where, spinnerString);
        }

    }

    public static void closeFrame() {

        showPreferencesFrame.setVisible(false);
        showPreferencesFrame.dispose();
        MenuItem.enableMenu(true);

    }

}
